*ASM
         TITLE 'RAHRCONV'
* ====================================================================
* =                                                                  =
* =    RAHRCONV: Converter program for Rexx Execs.                   =
* =                                                                  =
* =                                                                  =
* =     This is the converter for Rexx to service HTML GET           =
* =          requests (link a link). This request is serviced        =
* =          by the Encode function of the Web, the Decode is        =
* =          not used (and nulls out the server program to stop      =
* =          any call).                                              =
* =                                                                  =
* =     The URL is thus:                                             =
* =                                                                  =
* =     dns:socket/RAHRCONV/RHRX/X/rexxcommand:parms                 =
* =                                                                  =
* =              RHRX is the Alias Transaction, which is is just     =
* =                      CWBA with a TWA of 10 and runaway task      =
* =                      set off (to cope with Rexx function)        =
* =                                                                  =
* =              X    is just 'X' - or anything really: it just      =
* =                      gets around the default Analyser insisting  =
* =                      upon an alias program (which never gets     =
* =                      called or invoked in any way)               =
* =                                                                  =
* =              rexxcommand is the command to be run - it must      =
* =                          be registered to Rexx/CICS as a command =
* =                          in the usual way                        =
* =                                                                  =
* =              parms are upto the user. Note that spaces are NOT   =
* =                    allowed (nor %20s nor +s) due to the way      =
* =                    the CICS layers parse URLs. Use :s to         =
* =                    seperate parms (exec:a:b calls the Rexx       =
* =                    command 'EXEC' with parms of 'a:b')           =
* =                                                                  =
* =                                                                  =
* =    Books                                                         =
* =    -----                                                         =
* =                                                                  =
* =    You need to have these books around to understand what is     =
* =        going on:                                                 =
* =                                                                  =
* =                                                                  =
* =    SC33-1944 CICS Internet and External Interfaces Guide         =
* =                                                                  =
* =    SH21-0482 IBM Rexx Development System for CICS/ESA and        =
* =              Rexx Runtime facility for CICS/ESA Guide and        =
* =              Reference                                           =
* =                                                                  =
* =                                                                  =
* =    Rexx/CICS definitions                                         =
* =    ---------------------                                         =
* =                                                                  =
* =      All Rexx commands placed in the URL have to be defined      =
* =          to Rexx/CICS as commands. Place entries in the CICUSER  =
* =           RAHRINIT member along the lines of                     =
* =                                                                  =
* =            'DEFCMD REXXCICS execname = = execname ( REXX '       =
* =                                                                  =
* =           for each exec to be used.                              =
* =                                                                  =
* =                                                                  =
* =    Code Page Translation                                         =
* =    ---------------------                                         =
* =                                                                  =
* =    As Part 3 of SC33-1944 CICS Internet and External Interfaces  =
* =       Guide explains, all the output from this Rexx converter    =
* =       will undergo translation according to the analysers        =
* =       determination. You will need to code up an analyser that   =
* =       can determine if an image is being processed, and if       =
* =       so turn off EBCDIC<->ASCII translation.                    =
* =                                                                  =
* =       You can use the RAHWBANL analyser contained in SupportPac  =
* =       CA1G to control this translation. In RAHWBANL              =
* =       there are two supplied keysets called Image and Link.      =
* =       The Server programs in these keysets were setup to point   =
* =       to RAHRCONV (this program). The IMAGE keyset does not      =
* =       translate the body of the HTTP flow, whereas the LINK      =
* =       keyset does translate the output from EBCDIC to ASCII.     =
* =                                                                  =
* =       So, an URL using the RAHWBANL analyser, would be           =
* =                                                                  =
* =       dns:socket/&KS=IMAGE/exec:p1:p2    no translation          =
* =       dns:socket/&KS=LINK/exec:p1:p2        translation          =
* =                                                                  =
* =                                                                  =
* =    Security                                                      =
* =    --------                                                      =
* =                                                                  =
* =    As Part 3 of SC33-1944 CICS Internet and External Interfaces  =
* =       Guide explains, all this Rexx function will run under      =
* =       the Security context of the logonid set by the analyser    =
* =       (or via CWBC). This may give you a security exposure       =
* =       unless you code up an analyser to alter the security       =
* =       context.                                                   =
* =                                                                  =
* =       You can use the RAHWBANL analyser contained in SupportPac  =
* =       CA1G to set a specific security context. In RAHWBANL       =
* =       there are two supplied keysets called Image and Link.      =
* =       The Server programs in these keysets were setup to point   =
* =       to RAHRCONV (this program). Thus, you can set a specific   =
* =       logonid in these keysets or override in the URL.           =
* =                                                                  =
* =       dns:socket/&KS=IMAGE/exec:p1:p2    to run under the        =
* =       dns:socket/&KS=LINK/exec:p1:p2     logonid set in the      =
* =                                          given keysets           =
* =                                                                  =
* =                                                                  =
* =       dns:socket/&KS=IMAGE&UI=RAH/exec:p1:p2  to run under the   =
* =       dns:socket/&KS=IMAGE&UI=RAH/exec:p1:p2  RAH security       =
* =                                               context            =
* =                                                                  =
* =       However you set the logonid, you MUST ensure that it has   =
* =       been put in the authorised list of Rexx/CICS logonids      =
* =       by use of the AUTHUSER command. This will usually be       =
* =       done within the CICSTART member of the SCICEXEC PDS        =
* =       (used via the CICEXEC DDname)                              =
* =                                                                  =
* =                                                                  =
* =    Calling Rexx                                                  =
* =    ------------                                                  =
* =                                                                  =
* =    Rexx is invoked in the usual way via a link to the Rexx       =
* =         Component (I trust you have installed Rexx/CICS, put     =
* =         on all the latest fixes and got the REXX transaction     =
* =         to run!).                                                =
* =                                                                  =
* =    It then calls the RAHRMAIN Rexx/CICS command (setup as a      =
* =       command via RAHRINIT). You must put a call in the          =
* =       CICSTART member of the SCICEXEC PDS (used via the CICEXEC  =
* =       DDname) to define the RAHRMAIN command (and all the        =
* =       others you are using) along the lines of                   =
* =                                                                  =
* =       'EXEC RAHRINIT'                                            =
* =                                                                  =
* =       However, if you prefer, you can use the REXX transaction   =
* =       and issue the 'EXEC RAHRINIT' directly.                    =
* =                                                                  =
* =                                                                  =
* =    The RAHRMAIN exec then setup up the relevant Rexx/CICS        =
* =        environment (and assists) before calling the              =
* =        Rexx/CICS command (defined as that follwing the last      =
* =        single / in the URL upto the first : or blank) with       =
* =        the supplied parms (following on from the aforementioned  =
* =        :).                                                       =
* =                                                                  =
* =                                                                  =
* =                                                                  =
* =    Register Usage :                                              =
* =    ================                                              =
* =                                                                  =
* =        R0   ->                                                   =
* =        R1   ->                                                   =
* =        R2   ->                                                   =
* =        R3   ->                                                   =
* =        R4   ->                                                   =
* =        R5   ->                                                   =
* =        R6   -> Linkage Register                                  =
* =        R7   -> Base 1                                            =
* =        R8   -> Base 2                                            =
* =        R9   -> Base 3                                            =
* =        R10  -> DFHEISTG                                          =
* =        R11  -> EIB                                               =
* =        R12  -> TCA                                               =
* =        R13  -> CSA                                               =
* =        R14  ->                                                   =
* =        R15  ->                                                   =
* =                                                                  =
* =                                                                  =
* =                                                                  =
* =                                                                  =
* =    Copyright and Support                                         =
* =    =====================                                         =
* =                                                                  =
* =    This program is not supported by any way by IBM. It is        =
* =    distributed only to show techniques for CICS usage. It may    =
* =    be freely modified and adapted by your installation.          =
* =                                                                  =
* =                                                                  =
* =    Author:   Robert Harris,                                      =
* =              CBSeries Design,                                    =
* =              IBM Hursley Park,                                   =
* =              England.                                            =
* =                                                                  =
* =                                                                  =
* =    (C) Copyright IBM UK Limited, 1998.                           =
* =                                                                  =
* =    Licensed Materials - Property of IBM                          =
* =    SupportPac CA87                                               =
* =    US Government Users Restricted Rights - Use, duplication or   =
* =    disclosure restricted by GSA ADP Schedule Contract with IBM   =
* =    Corp.                                                         =
* =                                                                  =
* ====================================================================
*
         SPACE 2
         EJECT
         SPACE 2
         EJECT
*
* ====================================================================
* =                General declarations                              =
* ====================================================================
*
         SPACE 2
R0       EQU   0
R1       EQU   1
R2       EQU   2
R3       EQU   3
R4       EQU   4
R5       EQU   5
R6       EQU   6
R7       EQU   7
R8       EQU   8
R9       EQU   9
R10      EQU   10
R11      EQU   11
R12      EQU   12
R13      EQU   13
R14      EQU   14
R15      EQU   15
RA       EQU   10
RB       EQU   11
RC       EQU   12
RD       EQU   13
RE       EQU   14
RF       EQU   15
         SPACE 2
         EJECT
         SPACE 2
         EJECT
*
* ====================================================================
* =                Converter Dsects                                  =
* ====================================================================
*
         SPACE 2
         COPY  DFHWBCDD                     Converter commarea
         COPY  DFHWBUCD                     Converter equates
         SPACE 2
         EJECT
*
* ====================================================================
* =                Variables                                         =
* ====================================================================
*
         SPACE 2
DFHEISTG DSECT
         SPACE 2
* ===> Start of User defined Variables <===
         SPACE 2
EISSTART DS    0H                           Start of EIS
         SPACE 2
EIBSAVE  DS    F                            Save of EIB Register
         SPACE 2
CAP      DS    AL4                          Commarea Pointer
CAL      DS    F                                     Length
CAACT    DS    CL8                                   Action required
         SPACE 2
SAVECOMM DS    XL200                        Commarea on entry
COMMAREA DS    XL200                        Commarea used
CAPU     DS    AL4                                   address
CAPUC    DS    CL8                                            flat
         SPACE 2
         SPACE 2
RXCALL   DS    CL200                        Rexx Commarea
         SPACE 2
STARTBY  DS    CL2                          Transaction startcode
LOGON    DS    CL8                          Current UserId
         SPACE 2
RESP     DS    F                            EIB RC
RESP2    DS    F                                AC
         SPACE 2
MSGAREA  DS    0XL87                        Output Area
MSGAREAF DS    XL5                           WCC
MSGAREAM DS    CL80                          Message
MSGAREAB DS    XL2                           End field
         SPACE 2
TDMSGA   DS    0XL100                       TD Message area
TDMSGN   DS    XL10                            Time
TDMSGP1  DS    CL1
TDMSGTI  DS    XL8                             Time
TDMSGP2  DS    CL1
TDMSGTA  DS    XL8                             Transaction Number
TDMSGP3  DS    CL1
TDMSGM   DS    CL70                          Message
         SPACE 1
PH2      DS    XL2                          Conversion areas
         DS    0F
VALU2TO4 DS    XL4
WORK2TO4 DS    CL8
PACK2TO4 DS    CL16
OUTP2TO4 DS    CL4
PH4      DS    XL4
         DS    0F
VALU4TO8 DS    XL4
WORK4TO8 DS    CL8
PACK4TO8 DS    CL16
OUTP4TO8 DS    CL8
         SPACE 1
         DS    0D
SAVE1    DS    XL64                         Save Areas
SAVE2    DS    XL64
SAVE3    DS    XL64
SAVE4    DS    XL64
SAVE5    DS    XL64
FSAVE    DS    XL64
         SPACE 1
EISEND   DS    0H
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                Initialisation                                    =
* ====================================================================
*
         SPACE 2
RAHRCONV DFHEIENT CODEREG=(R7,R8,R9),                                  |
               DATAREG=(R10),                                          |
               EIBREG=(R11)
         SPACE 2
RAHRCONV AMODE 31
RAHRCONV RMODE ANY
         SPACE 2
         B     START
         SPACE 2
         DC    CL8'RAHRCONV'
         DC    CL8'&SYSDATE'
         DC    CL8'&SYSTIME'
         SPACE 2
START    DS    0H
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                Start of Program                                  =
* ====================================================================
*
         SPACE 2
RAHRCONV CSECT
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =     Initialise some Variables                                    =
* ====================================================================
*
*
* ====> Initialise variables
*
         SPACE 2
         ST    DFHEIBR,EIBSAVE              Save the EIB pointer
         XC    SAVECOMM,SAVECOMM            Clear the Commarea
         XC    COMMAREA,COMMAREA
         XC    CAP,CAP
         XC    CAL,CAL
         XC    RXCALL,RXCALL                Clear Rexx Commarea
         SPACE 2
*
* ====> Variables have been initialised
*
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                                                                  =
* =     See how we got going                                         =
* =                                                                  =
* ====================================================================
*
*
* ====> Get StartCode and Environment
*
         SPACE 1
GG       DS    0H
         SPACE 2
         EXEC  CICS ASSIGN STARTCODE(STARTBY)                          |
                           USERID(LOGON)                               |
                           NOHANDLE                                    |
                           RESP(RESP)                                  |
                           RESP2(RESP2)
         SPACE 1
*
* ====> Get Commarea and Length
*
         SPACE 2
GG1      DS    0H
         SPACE 1
         MVC   CAP,DFHEICAP                 Get Commarea Address
         MVC   CAL+2(2),EIBCALEN            Get Commarea Length
         SPACE 1
GGX      DS    0H
         SPACE 1
*
* ====> Start Info has been gathered
*
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                                                                  =
* =     Look at the Commarea                                         =
* =                                                                  =
* =     The Commarea (which should exist) determines whether         =
* =         Encode (Rexx->Browser)                                   =
* =     or  Decode (Browser->Rexx)  is being run.                    =
* =                                                                  =
* =                                                                  =
* =     Once this action has been determined, then copy the          =
* =          now correclty determined Commarea.                      =
* =                                                                  =
* ====================================================================
*
*
* ====> Grab the Commarea, if its around and OK
*
GC       DS    0H
         SPACE 1
         L     R15,CAP                        Address the Commarea
         LTR   R15,R15                        Any Commarea ?
         BZ    GC1                             No  - no function
         L     R14,CAL                        Look at Commarea Length
         LTR   R14,R14                        Any Commarea ?
         BZ    GC1                             No  - no function
         C     R14,=AL4(L'COMMAREA)           Enough Room for it?
         BNL   GC1                             No  - no function
         B     GC2                             Yes - Commarea present
         SPACE 1
*
* ====> No Commarea around
*
         SPACE 1
GC1      DS    0H
         SPACE 1
         XC    MSGAREA,MSGAREA
         L     R14,=AL4(MSG01)
         MVC   MSGAREAM,0(R14)
         SPACE 1
         BAL   R6,MSGTOTD
         SPACE 1
         B     EXITX
         SPACE 1
         SPACE 1
*
* ====> See if the Commarea contains a valid function
*
         SPACE 1
GC2      DS    0H
         SPACE 1
         MVC   CAACT,0(R15)                 Get the Function required
         OC    CAACT,=XL8'4040404040404040' Put into Upper Case
         SPACE 1
         CLC   CAACT,=CL8'>DECODE '         Known function?
         BE    GC4                           Yes - continue
         CLC   CAACT,=CL8'>ENCODE '
         BE    GC5
         B     GC3                           No  - error
         SPACE 1
*
* ====> Unknown Commarea function
*
         SPACE 1
GC3      DS    0H
         SPACE 1
         XC    MSGAREA,MSGAREA
         L     R14,=AL4(MSG02)
         MVC   MSGAREAM,0(R14)
         MVC   MSGAREAM+41(8),CAACT
         SPACE 1
         BAL   R6,MSGTOTD
         SPACE 1
         B     EXITX
         SPACE 1
*
* ====> Decode requested, get the Commarea
*
         SPACE 1
GC4      DS    0H
         SPACE 1
         L     R14,CAL                      Look at Commarea Length
         C     R14,=AL4(L'DECODE_PARMS)     Correct Length?
         BE    GC41                          Yes - continue
         SPACE 1
         XC    MSGAREA,MSGAREA
         L     R14,=AL4(MSG03)
         MVC   MSGAREAM,0(R14)
         LA    R14,CAL
         LA    R15,MSGAREAM+49
         BAL   R6,CONV4TO8
         SPACE 1
         BAL   R6,MSGTOTD
         SPACE 1
         B     EXITX
         SPACE 1
GC41     DS    0H
         SPACE 1
         LA    R0,SAVECOMM                  Copy the Decode Commarea
         L     R1,=AL4(L'DECODE_PARMS)
         L     R14,CAP
         LR    R15,R1
         MVCL  R0,R14
         SPACE 1
         MVC   COMMAREA,SAVECOMM            and set the user one
         LA    R15,COMMAREA                     with its address
         ST    R15,CAPU
         SPACE 1
         B     GCX                          and exit block
         SPACE 1
*
* ====> Encode requested, get the Commarea
*
         SPACE 1
GC5      DS    0H
         SPACE 1
         L     R14,CAL                      Look at Commarea Length
         C     R14,=AL4(L'ENCODE_PARMS)     Correct Length?
         BE    GC51                          Yes - continue
         SPACE 1
         XC    MSGAREA,MSGAREA
         L     R14,=AL4(MSG04)
         MVC   MSGAREAM,0(R14)
         LA    R14,CAL
         LA    R15,MSGAREAM+49
         BAL   R6,CONV4TO8
         SPACE 1
         BAL   R6,MSGTOTD
         SPACE 1
         B     EXITX
         SPACE 1
GC51     DS    0H
         SPACE 1
         LA    R0,SAVECOMM                  Copy the Encode Commarea
         L     R1,=AL4(L'ENCODE_PARMS)
         L     R14,CAP
         LR    R15,R1
         MVCL  R0,R14
         SPACE 1
         MVC   COMMAREA,SAVECOMM            and set the user one
         LA    R15,COMMAREA                     with its address
         ST    R15,CAPU
         SPACE 1
         B     GCX                          and exit block
         SPACE 1
*
* ====> Action and Commarea correctly determined
*
         SPACE 1
GCX      DS    0H
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                                                                  =
* =     Goto the correct function                                    =
* =                                                                  =
* =                                                                  =
* =  At this point we have determined the Encode/Decode action       =
* =     required and checked that the Commarea looks OK for the      =
* =     function.                                                    =
* =                                                                  =
* =  Thus, as the processing for the actions are in their own        =
* =        CSECT, we now go off to these CSECTS, returning           =
* =        here after the processing has finished                    =
* =                                                                  =
* =                                                                  =
* ====================================================================
*
*
* ====> Look at Commarea for Conversation Continuation
*
         SPACE 1
PC       DS    0H
         SPACE 2
         XC    MSGAREA,MSGAREA              Trace Commarea
         MVC   MSGAREAM,MSGI1
         MVC   MSGAREAM+24(50),COMMAREA
         BAL   R6,MSGTOTD
         SPACE 1
         CLC   CAACT,=CL8'>DECODE '         Decode wanted?
         BE    PCD                           Yes - goto Decode
         B     PCE                           No  - goto Encode
         SPACE 1
*
* ====> Run Decode function
*
PCD      DS    0H
         SPACE 1
         XC    MSGAREA,MSGAREA              Trace Decode call
         MVC   MSGAREAM,MSGI2
         BAL   R6,MSGTOTD
         SPACE 1
         L     R15,=AL4(RXRDEC)             Address Decode CSECT
         BALR  R14,R15                      Run Decode actions
         SPACE 1
         XC    MSGAREA,MSGAREA              Trace Decode return
         MVC   MSGAREAM,MSGI3
         BAL   R6,MSGTOTD
         SPACE 1
         B     PCX                          and exit
         SPACE 1
*
* ====> Run Encode function
*
         SPACE 1
PCE      DS    0H
         SPACE 1
         XC    MSGAREA,MSGAREA              Trace Decode call
         MVC   MSGAREAM,MSGI4
         BAL   R6,MSGTOTD
         SPACE 1
         L     R15,=AL4(RXRENC)             Address Encode CSECT
         BALR  R14,R15                      Run Encode actions
         SPACE 1
         XC    MSGAREA,MSGAREA              Trace Encode return
         MVC   MSGAREAM,MSGI5
         BAL   R6,MSGTOTD
         SPACE 1
         B     PCX                          and exit
         SPACE 1
*
* ====> End of Encode/Decode function
*
         SPACE 1
PCX      DS    0H
         SPACE 2
         EJECT
         SPACE 2
* ====================================================================
* =                                                                  =
* =      Update the REAL Commarea from the local copy                =
* =                                                                  =
* =      The Saved Commarea is first updated with the fields that    =
* =          are defined to be updateable, and then the whole        =
* =          of this unsaved commarea is copied back into            =
* =          the CICS-supplied area.                                 =
* =                                                                  =
* =                                                                  =
* ====================================================================
*
* ====> Trace output commarea
*
         SPACE 1
CU       DS    0H
         SPACE 1
         XC    MSGAREA,MSGAREA              Trace Commarea
         MVC   MSGAREAM,MSGI6
         MVC   MSGAREAM+24(50),COMMAREA
         BAL   R6,MSGTOTD
         SPACE 1
         CLC   CAACT,=CL8'>DECODE '         Decode wanted?
         BE    CUD                           Yes - goto Decode
         B     CUE                           No  - goto Encode
         SPACE 1
*
* ====> Update Commarea for Decode
*
CUD      DS    0H
         SPACE 1
         LA    R2,SAVECOMM                  Address Saved Commarea
         LA    R3,COMMAREA                  Address User  Commarea
         SPACE 1
         LR    R0,R2
         AH    R0,=AL2(DECODE_DATA_PTR-DECODE_PARMS)
         L     R1,=AL4(L'DECODE_DATA_PTR)
         LR    R14,R3
         AH    R14,=AL2(DECODE_DATA_PTR-DECODE_PARMS)
         LR    R15,R1
         MVCL  R0,R14
         SPACE 1
         LR    R0,R2
         AH    R0,=AL2(DECODE_INPUT_DATA_LEN-DECODE_PARMS)
         L     R1,=AL4(L'DECODE_INPUT_DATA_LEN)
         LR    R14,R3
         AH    R14,=AL2(DECODE_INPUT_DATA_LEN-DECODE_PARMS)
         LR    R15,R1
         MVCL  R0,R14
         SPACE 1
         LR    R0,R2
         AH    R0,=AL2(DECODE_OUTPUT_DATA_LEN-DECODE_PARMS)
         L     R1,=AL4(L'DECODE_OUTPUT_DATA_LEN)
         LR    R14,R3
         AH    R14,=AL2(DECODE_OUTPUT_DATA_LEN-DECODE_PARMS)
         LR    R15,R1
         MVCL  R0,R14
         SPACE 1
         LR    R0,R2
         AH    R0,=AL2(DECODE_REASON-DECODE_PARMS)
         L     R1,=AL4(L'DECODE_REASON)
         LR    R14,R3
         AH    R14,=AL2(DECODE_REASON-DECODE_PARMS)
         LR    R15,R1
         MVCL  R0,R14
         SPACE 1
         LR    R0,R2
         AH    R0,=AL2(DECODE_RESPONSE-DECODE_PARMS)
         L     R1,=AL4(L'DECODE_RESPONSE)
         LR    R14,R3
         AH    R14,=AL2(DECODE_RESPONSE-DECODE_PARMS)
         LR    R15,R1
         MVCL  R0,R14
         SPACE 1
         LR    R0,R2
         AH    R0,=AL2(DECODE_SERVER_PROGRAM-DECODE_PARMS)
         L     R1,=AL4(L'DECODE_SERVER_PROGRAM)
         LR    R14,R3
         AH    R14,=AL2(DECODE_SERVER_PROGRAM-DECODE_PARMS)
         LR    R15,R1
         MVCL  R0,R14
         SPACE 1
         LR    R0,R2
         AH    R0,=AL2(DECODE_USER_TOKEN-DECODE_PARMS)
         L     R1,=AL4(L'DECODE_USER_TOKEN)
         LR    R14,R3
         AH    R14,=AL2(DECODE_USER_TOKEN-DECODE_PARMS)
         LR    R15,R1
         MVCL  R0,R14
         SPACE 1
         B     CUC
         SPACE 1
*
* ====> Update Commarea for Encode
*
CUE      DS    0H
         SPACE 1
         LA    R2,SAVECOMM                  Address Saved Commarea
         LA    R3,COMMAREA                  Address User  Commarea
         SPACE 1
         LR    R0,R2
         AH    R0,=AL2(ENCODE_DATA_PTR-DECODE_PARMS)
         L     R1,=AL4(L'ENCODE_DATA_PTR)
         LR    R14,R3
         AH    R14,=AL2(ENCODE_DATA_PTR-DECODE_PARMS)
         LR    R15,R1
         MVCL  R0,R14
         SPACE 1
         LR    R0,R2
         AH    R0,=AL2(ENCODE_REASON-DECODE_PARMS)
         L     R1,=AL4(L'ENCODE_REASON)
         LR    R14,R3
         AH    R14,=AL2(ENCODE_REASON-DECODE_PARMS)
         LR    R15,R1
         MVCL  R0,R14
         SPACE 1
         LR    R0,R2
         AH    R0,=AL2(ENCODE_RESPONSE-DECODE_PARMS)
         L     R1,=AL4(L'ENCODE_RESPONSE)
         LR    R14,R3
         AH    R14,=AL2(ENCODE_RESPONSE-DECODE_PARMS)
         LR    R15,R1
         MVCL  R0,R14
         SPACE 1
         B     CUC
         SPACE 1
*
* ====> Saved commarea has been updated, now update the Real one
*
CUC      DS    0H
         SPACE 2
         XC    MSGAREA,MSGAREA              Trace Before Commarea
         MVC   MSGAREAM,MSGI7
         L     R1,CAP
         MVC   MSGAREAM+24(50),0(R1)
         BAL   R6,MSGTOTD
         SPACE 1
         L     R0,CAP                       Address Real Commarea
         L     R1,CAL                       Get Real CAommarea len
         LA    R14,SAVECOMM                 Point to updared saved
         LR    R15,R1                       No padding
         MVCL  R0,R14                       Updates CICS Commarea
         SPACE 1
         XC    MSGAREA,MSGAREA              Trace Real Commarea
         MVC   MSGAREAM,MSGI8
         L     R1,CAP
         MVC   MSGAREAM+24(50),0(R1)
         BAL   R6,MSGTOTD
*
* ====> Commarea updated with Decode and Encode data
*
CUX      DS    0H
         SPACE 2
         B     EXIT                         and exit CICS
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                                                                  =
* =         End of Logic - return to CICS                            =
* =                                                                  =
* ====================================================================
*
         SPACE 2
EXITX    DS    0H
         SPACE 2
         SPACE 2
EXIT     DS    0H
         SPACE 2
         EXEC  CICS RETURN
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                Constants                                         =
* ====================================================================
*
         SPACE 2
EISLEN   DC    Y(EISEND-EISSTART)           Length of EXEC Storage
         SPACE 1
         SPACE 2
MSGTDQ   DC    CL4'RAHW'                    Message TDQ
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                Information Messages                              =
* ====================================================================
*
         SPACE 2
*                   0....+....1....+....2....+....3....+....4....+....5
*              ....+....6....+....7....+....
MSGI1    DC    CL80'RAHRC9001I Commarea is <xxxxxxxxxxxxxxxxxxxxxxxxxxx|
               xxxxxxxxxxxxxxxxxxxxx>       '
MSGI2    DC    CL80'RAHRC9002I About to link to Rexx Decode            |
                                            '
MSGI3    DC    CL80'RAHRC9003I Returned from Rexx Decode               |
                                            '
MSGI4    DC    CL80'RAHRC9004I About to link to Rexx Encode            |
                                            '
MSGI5    DC    CL80'RAHRC9005I Returned from Rexx Encode               |
                                            '
MSGI6    DC    CL80'RAHRC9006I Commarea is <xxxxxxxxxxxxxxxxxxxxxxxxxxx|
               xxxxxxxxxxxxxxxxxxxxx>       '
MSGI7    DC    CL80'RAHRC9007I Old CA  was <xxxxxxxxxxxxxxxxxxxxxxxxxxx|
               xxxxxxxxxxxxxxxxxxxxx>       '
MSGI8    DC    CL80'RAHRC9008I Real CA  is <xxxxxxxxxxxxxxxxxxxxxxxxxxx|
               xxxxxxxxxxxxxxxxxxxxx>       '
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                Literals                                          =
* ====================================================================
*
         SPACE 2
         LTORG
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                                                                  =
* =            Writing Subroutines                                   =
* =            -------------------                                   =
* =                                                                  =
* =   These routines send debugging or Error messages. They are      =
* =         linked on R6, and use SAVE2 as their Savearea.           =
* =                                                                  =
* =                                                                  =
* =   MSGTOTD -> Write a Message to a TDQ                            =
* =                                                                  =
* =                                                                  =
* ====================================================================
*
         SPACE 2
*
* =====> Output Message to TDQ
*
*               Split the Message so that the message number
*                     (1st 10 bytes) comer out before the time and
*                     transaction number
*
         SPACE 2
MSGTOTD  DS    0H
         SPACE 2
         STM   R0,R15,SAVE2                 Save regs
         SPACE 1
         XC    TDMSGA,TDMSGA
         MVC   TDMSGN,MSGAREAM+0
         MVI   TDMSGP1,C' '
         UNPK  TDMSGTI,EIBTIME
         MVC   TDMSGTI+0(2),TDMSGTI+2
         MVI   TDMSGTI+2,C':'
         MVC   TDMSGTI+3(2),TDMSGTI+4
         MVI   TDMSGTI+5,C':'
         MVI   TDMSGP2,C' '
         MVI   TDMSGTA,C'0'
         LA    R14,EIBTASKN
         LA    R15,TDMSGTA+1
         BAL   R6,CONV4TO8
         MVI   TDMSGP3,C' '
         MVC   TDMSGM,MSGAREAM+11
         SPACE 1
         EXEC  CICS WRITEQ TD QUEUE(MSGTDQ)                            |
               FROM(TDMSGA)                                            |
               LENGTH(=AL2(L'TDMSGA))                                  |
               NOHANDLE
         SPACE 1
         LM    R0,R15,SAVE2                 Restore regs
         BR    R6                           Return
         SPACE 2
         LM    R0,R15,SAVE2                 Restore regs
         BR    R6                           Return
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                Literals                                          =
* ====================================================================
*
         SPACE 2
         LTORG
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                                                                  =
* =                Conversion Subroutines                            =
* =                ----------------------                            =
* =                                                                  =
* =   These are general conversion routines. They are all linked     =
* =         on R6 and use SAVE1 as their savearea                    =
* =                                                                  =
* =               R14-> Input   R15->Output                          =
* =                                                                  =
* =  CONV2TO4  =  XL2 -> CL4                                         =
* =  CONV4TO8  =  XL4 -> CL8                                         =
* =  CONVCTOI  =  CL8 -> F    omitting non-numerics Right-to-Left    =
* =                                                                  =
* =                                                                  =
* ====================================================================
*
         SPACE 2
*
* =====> Convert XL2->CL4  (R14->XL2, R15->CL4)
*
         SPACE 2
CONV2TO4 DS    0H
         SPACE 2
         STM   R0,R15,SAVE1                 Save regs
         SPACE 1
         MVC   VALU2TO4,0(R14)              Get Input XL2
         SPACE 1
         MVC   OUTP2TO4,=CL4'00000000'      Clear return area
         SPACE 1
         XR    R14,R14                      Clear Work Reg
         IC    R14,VALU2TO4+2               Load Source Byte
         N     R14,=XL4'000000F0'           Set the Nibble
         SRA   R14,4                        000000x0 -> 0000000x
         LA    R15,=CL16'0123456789ABCDEF'  Address Pattern
         AR    R15,R14                      Point to Printable char
         MVC   OUTP2TO4+0(1),0(R15)         Save the Printable char
         SPACE 1
         XR    R14,R14
         IC    R14,VALU2TO4+2               ..x.
         N     R14,=XL4'0000000F'           .x
         LA    R15,=CL16'0123456789ABCDEF'
         AR    R15,R14
         MVC   OUTP2TO4+1(1),0(R15)         x...
         SPACE 1
         XR    R14,R14
         IC    R14,VALU2TO4+3
         N     R14,=XL4'000000F0'           ..x.
         SRA   R14,4                        000000x0 -> 0000000x
         LA    R15,=CL16'0123456789ABCDEF'  x.
         AR    R15,R14
         MVC   OUTP2TO4+2(1),0(R15)         ..x.
         SPACE 1
         XR    R14,R14
         IC    R14,VALU2TO4+3               ...x
         N     R14,=XL4'0000000F'           .x
         LA    R15,=CL16'0123456789ABCDEF'
         AR    R15,R14
         MVC   OUTP2TO4+3(1),0(R15)         ...x
         SPACE 1
         LM    R0,R15,SAVE1                 Restore regs
         MVC   0(4,R15),OUTP2TO4            Copy Converted CL4
         SPACE 1
         BR    R6                           Return
         SPACE 2
*
* =====> Convert XL4->CL8  (R14->XL4, R15->CL8)
*
         SPACE 2
CONV4TO8 DS    0H
         SPACE 2
         STM   R0,R15,SAVE1                 Save regs
         SPACE 1
         MVC   VALU4TO8,0(R14)              Get Input XL4
         SPACE 1
         MVC   OUTP4TO8,=CL8'00000000'      Clear return area
         SPACE 1
         XR    R14,R14                      Clear Work Reg
         IC    R14,VALU4TO8+0               Load Source Byte
         N     R14,=XL4'000000F0'           Set the Nibble
         SRA   R14,4                        000000x0 -> 0000000x
         LA    R15,=CL16'0123456789ABCDEF'  Address Pattern
         AR    R15,R14                      Point to Printable char
         MVC   OUTP4TO8+0(1),0(R15)         Save the Printable char
         SPACE 1
         XR    R14,R14
         IC    R14,VALU4TO8+0               x...
         N     R14,=XL4'0000000F'           .x
         LA    R15,=CL16'0123456789ABCDEF'
         AR    R15,R14
         MVC   OUTP4TO8+1(1),0(R15)         .x......
         SPACE 1
         XR    R14,R14
         IC    R14,VALU4TO8+1
         N     R14,=XL4'000000F0'           .x..
         SRA   R14,4                        000000x0 -> 0000000x
         LA    R15,=CL16'0123456789ABCDEF'  x.
         AR    R15,R14
         MVC   OUTP4TO8+2(1),0(R15)         ..x.....
         SPACE 1
         XR    R14,R14
         IC    R14,VALU4TO8+1               .x..
         N     R14,=XL4'0000000F'           .x
         LA    R15,=CL16'0123456789ABCDEF'
         AR    R15,R14
         MVC   OUTP4TO8+3(1),0(R15)         ...x....
         SPACE 1
         XR    R14,R14
         IC    R14,VALU4TO8+2
         N     R14,=XL4'000000F0'           ..x.
         SRA   R14,4                        000000x0 -> 0000000x
         LA    R15,=CL16'0123456789ABCDEF'  x.
         AR    R15,R14
         MVC   OUTP4TO8+4(1),0(R15)         ....x...
         SPACE 1
         XR    R14,R14
         IC    R14,VALU4TO8+2               ..x.
         N     R14,=XL4'0000000F'           .x
         LA    R15,=CL16'0123456789ABCDEF'
         AR    R15,R14
         MVC   OUTP4TO8+5(1),0(R15)         .....x..
         SPACE 1
         XR    R14,R14
         IC    R14,VALU4TO8+3
         N     R14,=XL4'000000F0'           ...x
         SRA   R14,4                        000000x0 -> 0000000x
         LA    R15,=CL16'0123456789ABCDEF'  x.
         AR    R15,R14
         MVC   OUTP4TO8+6(1),0(R15)         ......x.
         SPACE 1
         XR    R14,R14
         IC    R14,VALU4TO8+3               ...x
         N     R14,=XL4'0000000F'           .x
         LA    R15,=CL16'0123456789ABCDEF'
         AR    R15,R14
         MVC   OUTP4TO8+7(1),0(R15)         .......x
         SPACE 1
         LM    R0,R15,SAVE1                 Restore regs
         MVC   0(8,R15),OUTP4TO8            Copy Converted CL8
         BR    R6                           Return
         SPACE 2
         EJECT
*
* =====> Convert CL8->F    (R14->CL8, R15->F)
*
*        Non numerics      R0 = used in Multiply, ignored
*        are ignored       R1 = Char, then numeric Digit
*                          R2 = Counter register
*                          R4 = used in Multiply, ignored
*                          R5 = Next multiplier
         SPACE 2
CONVCTOI DS    0H
         SPACE 2
         STM   R0,R15,SAVE1                 Save regs
         SPACE 1
         XR    R2,R2                        Clear Count Register
         L     R5,=F'1'                     Initial Multiplier
         SPACE 1
CTOI8    DS    0H
         SPACE 1
         CLI   7(R14),C'0'                  Integer?
         BL    CTOI7                         No  - omit
         CLI   7(R14),C'9'                  Integer?
         BH    CTOI7                         No  - omit
         XR    R1,R1
         ICM   R1,B'0001',7(R14)             Yes - Put into Calc Reg
         S     R1,=XL4'000000F0'                   Get digit
         MR    R0,R5                               Up digit
         M     R4,=F'10'                           Up multiplier
         AR    R2,R1                               Add in integer
         SPACE 1
CTOI7    DS    0H
         SPACE 1
         CLI   6(R14),C'0'                  Integer?
         BL    CTOI6                         No  - omit
         CLI   6(R14),C'9'                  Integer?
         BH    CTOI6                         No  - omit
         XR    R1,R1
         ICM   R1,B'0001',6(R14)             Yes - Put into Calc Reg
         S     R1,=XL4'000000F0'                   Get digit
         MR    R0,R5                               Up digit
         M     R4,=F'10'                           Up multiplier
         AR    R2,R1                               Add in integer
         SPACE 1
CTOI6    DS    0H
         SPACE 1
         CLI   5(R14),C'0'                  Integer?
         BL    CTOI5                         No  - omit
         CLI   5(R14),C'9'                  Integer?
         BH    CTOI5                         No  - omit
         XR    R1,R1
         ICM   R1,B'0001',5(R14)             Yes - Put into Calc Reg
         S     R1,=XL4'000000F0'                   Get digit
         MR    R0,R5                               Up digit
         M     R4,=F'10'                           Up multiplier
         AR    R2,R1                               Add in integer
         SPACE 1
CTOI5    DS    0H
         SPACE 1
         CLI   4(R14),C'0'                  Integer?
         BL    CTOI4                         No  - omit
         CLI   4(R14),C'9'                  Integer?
         BH    CTOI4                         No  - omit
         XR    R1,R1
         ICM   R1,B'0001',4(R14)             Yes - Put into Calc Reg
         S     R1,=XL4'000000F0'                   Get digit
         MR    R0,R5                               Up digit
         M     R4,=F'10'                           Up multiplier
         AR    R2,R1                               Add in integer
         SPACE 1
CTOI4    DS    0H
         SPACE 1
         CLI   3(R14),C'0'                  Integer?
         BL    CTOI3                         No  - omit
         CLI   3(R14),C'9'                  Integer?
         BH    CTOI3                         No  - omit
         XR    R1,R1
         ICM   R1,B'0001',3(R14)             Yes - Put into Calc Reg
         S     R1,=XL4'000000F0'                   Get digit
         MR    R0,R5                               Up digit
         M     R4,=F'10'                           Up multiplier
         AR    R2,R1                               Add in integer
         SPACE 1
CTOI3    DS    0H
         SPACE 1
         CLI   2(R14),C'0'                  Integer?
         BL    CTOI2                         No  - omit
         CLI   2(R14),C'9'                  Integer?
         BH    CTOI2                         No  - omit
         XR    R1,R1
         ICM   R1,B'0001',2(R14)             Yes - Put into Calc Reg
         S     R1,=XL4'000000F0'                   Get digit
         MR    R0,R5                               Up digit
         M     R4,=F'10'                           Up multiplier
         AR    R2,R1                               Add in integer
         SPACE 1
CTOI2    DS    0H
         SPACE 1
         CLI   1(R14),C'0'                  Integer?
         BL    CTOI1                         No  - omit
         CLI   1(R14),C'9'                  Integer?
         BH    CTOI1                         No  - omit
         XR    R1,R1
         ICM   R1,B'0001',1(R14)             Yes - Put into Calc Reg
         S     R1,=XL4'000000F0'                   Get digit
         MR    R0,R5                               Up digit
         M     R4,=F'10'                           Up multiplier
         AR    R2,R1                               Add in integer
         SPACE 1
CTOI1    DS    0H
         SPACE 1
         CLI   0(R14),C'0'                  Integer?
         BL    CTOI0                         No  - omit
         CLI   0(R14),C'9'                  Integer?
         BH    CTOI0                         No  - omit
         XR    R1,R1
         ICM   R1,B'0001',0(R14)             Yes - Put into Calc Reg
         S     R1,=XL4'000000F0'                   Get digit
         MR    R0,R5                               Up digit
         M     R4,=F'10'                           Up multiplier
         AR    R2,R1                               Add in integer
         SPACE 1
CTOI0    DS    0H
         SPACE 1
         ST    R2,0(R15)                    Saved Converted CL8
         LM    R0,R15,SAVE1                 Restore regs
         BR    R6                           Return
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                Literals                                          =
* ====================================================================
*
         SPACE 2
         LTORG
         SPACE 2
         EJECT
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                                                                  =
* =                RXRDEC Decode routine                             =
* =                ----------------------                            =
* =                                                                  =
* =   This routine is the RXRDEC Decode processing CSECT.            =
* =                                                                  =
* =   It is linked on R14, andresets all the Base Registers for its  =
* =      own use (Data registers are unchanged).                     =
* =                                                                  =
* =      So call by L    R15,=AL4(RXRDEC)                            =
* =                 BALR R14,R15                                     =
* =                                                                  =
* =                                                                  =
* =      care must be taken to establish the correct environmemt     =
* =      when using Mainline functional routines. SAVE5 is used      =
* =      as the Savearea.                                            =
* =                                                                  =
* =                                                                  =
* =   Note that this module puts in the HTML at Encode time: thus,   =
* =        this routine is strictly unneccessary. However, it        =
* =        does force the server program to nulls to prevent a       =
* =        non-existant backend from running.                        =
* =                                                                  =
* =   Processing must manipule the version of the Commarea in        =
* =      COMMAREA, and ensure that any areas replaced therein are    =
* =      properly Freemained.                                        =
* =                                                                  =
* =                                                                  =
* =   Register usage :  R7  -> Base Register                         =
* =                     R8  -> Base Register                         =
* =                     R9  -> Base Register                         =
* =                                                                  =
* =                     all registers are put back into their        =
* =                     saved state upon return                      =
* =                                                                  =
* =                                                                  =
* =                                                                  =
* ====================================================================
*
         SPACE 2
RXRDEC   CSECT
         SPACE 2
RXRDEC   AMODE 31
RXRDEC   RMODE ANY
         PUSH USING                         Save Addressibility
         USING RXRDEC,R7,R8,R9              Set local Addressibility
         STM   R0,R15,SAVE5                 Save regs
         SPACE 1
*
* =====> Establish new Base Registers
*
         SPACE 1
         LR    R7,R15                       Load 1st Base Reg
         LA    R8,X'FFF'(,R7)               Set  2nd Base REg
         LA    R8,1(,R8)
         LA    R9,X'FFF'(,R8)               Set  3rd Base REg
         LA    R9,1(,R8)
         SPACE 1
*
* =====> Trace Entry
*
         SPACE 1
         XC    MSGAREA,MSGAREA              Trace Entry
         MVC   MSGAREAM,MSGDI1
         STM   R0,R15,FSAVE
         L     R15,=AL4(MSGTOTD)
         LM    R0,R14,SAVE5
         BALR  R6,R15
         LM    R0,R15,FSAVE
         SPACE 1
*
* =====> Remove any fake program (so get back to the browser)
*
         SPACE 1
DC1      DS    0H
         SPACE 1
         L     R14,CAPU
         XR    R15,R15
         MVC   DECODE_SERVER_PROGRAM-DECODE_PARMS(8,R14),=XL8'000000000|
               0000000'
         MVC   DECODE_RESPONSE-DECODE_PARMS(4,R14),=F'0'  RC
         MVC   DECODE_REASON-DECODE_PARMS(4,R14),=F'0'    AC
         SPACE 1
DC11     DS    0H
         SPACE 1
*
* =====> Request succeeded
*
         SPACE 1
DCXY     DS    0H
         SPACE 1
         B     DCX                          Exit
         SPACE 1
*
* =====> Request failed
*
         SPACE 1
DCXN     DS    0H
         SPACE 1
         B     DCX                          Exit
         SPACE 1
*
* =====> Return to caller
*
         SPACE 1
DCX      DS    0H
         SPACE 1
         XC    MSGAREA,MSGAREA
         MVC   MSGAREAM,MSGDI2              Trace exit
         STM   R0,R15,FSAVE
         L     R15,=AL4(MSGTOTD)
         LM    R0,R14,SAVE5
         BALR  R6,R15
         LM    R0,R15,FSAVE
         SPACE 1
         LM    R0,R15,SAVE5                 Restore regs
         BR    R14                          Return
         POP   USING                        Restore Addressibility
         SPACE 2
*
* =====> Decode Info Messages
*
*                   0....+....1....+....2....+....3....+....4....+....5
*              ....+....6....+....7....+....
MSGDI1   DC    CL80'RAHRC9101I Entering Decode routine                 |
                                            '
MSGDI2   DC    CL80'RAHRC9102I Leaving Decode routine                  |
                                            '
         SPACE 2
         EJECT
*
* ====================================================================
* =             Decode Literals                                      =
* ====================================================================
*
         SPACE 2
         LTORG
         SPACE 2
         EJECT
         EJECT
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                                                                  =
* =                RXRENC Decode routine                             =
* =                ----------------------                            =
* =                                                                  =
* =   This routine is the RXRENC Encode processing CSECT.            =
* =                                                                  =
* =   It is linked on R14, andresets all the Base Registers for its  =
* =      own use (Data registers are unchanged).                     =
* =                                                                  =
* =      So call by L    R15,=AL4(RXRENC)                            =
* =                 BALR R14,R15                                     =
* =                                                                  =
* =                                                                  =
* =      care must be taken to establish the correct environmemt     =
* =      when using Mainline functional routines. SAVE5 is used      =
* =      as the Savearea.                                            =
* =                                                                  =
* =   The Encode routine invokes Rexx Commands and returns the       =
* =       results to the Web layers (which then go directly to       =
* =       the browser).                                              =
* =                                                                  =
* =   Processing must manipule the version of the Commarea in        =
* =      COMMAREA, and ensure that any areas replaced therein are    =
* =      properly Freemained.                                        =
* =                                                                  =
* =                                                                  =
* =   Register usage :  R7  -> Base Register                         =
* =                     R8  -> Base Register                         =
* =                     R9  -> Base Register                         =
* =                                                                  =
* =                     all registers are put back into their        =
* =                     saved state upon return                      =
* =                                                                  =
* =                                                                  =
* =                                                                  =
* ====================================================================
*
         SPACE 2
RXRENC   CSECT
         SPACE 2
RXRENC   AMODE 31
RXRENC   RMODE ANY
         PUSH USING                         Save Addressibility
         USING RXRENC,R7,R8,R9              Set local Addressibility
         STM   R0,R15,SAVE5                 Save regs
         SPACE 1
*
* =====> Establish new Base Registers
*
         SPACE 1
         LR    R7,R15                       Load 1st Base Reg
         LA    R8,X'FFF'(,R7)               Set  2nd Base REg
         LA    R8,1(,R8)
         LA    R9,X'FFF'(,R8)               Set  3rd Base REg
         LA    R9,1(,R8)
         SPACE 1
*
* =====> Trace Entry
*
         SPACE 1
         XC    MSGAREA,MSGAREA              Trace Entry
         MVC   MSGAREAM,MSGEI1
         STM   R0,R15,FSAVE
         L     R15,=AL4(MSGTOTD)
         LM    R0,R14,SAVE5
         BALR  R6,R15
         LM    R0,R15,FSAVE
         SPACE 1
*
* =====> Setup the Rexx command
* =====>
* =====>           p1 = flattened Commarea address
* =====>           (
* =====>           o1 = A E to indicate Decode function
* =====>
* =====>
* =====>           Note that the first 16 bytes must be blank
* =====>                (how do I know that, it is not documented
* =====>                 that this is so - well, trial and error!)
* =====>
* =====>
*
         SPACE 1
EC0      DS    0H
         SPACE 1
         STM   R0,R15,FSAVE
         LA    R14,CAPU                     Address           Commarea
         LA    R15,CAPUC                    Address flattened pointer
         L     R1,=AL4(CONV4TO8)
         LM    R2,R13,SAVE5+8
         BALR  R6,R1                        Flattenen CAP
         LM    R0,R15,FSAVE
         SPACE 1
         MVC   RXCALL,=CL200' '             Clear Rexx parm area
         MVC   RXCALL+17(08),=CL8'RAHRMAIN' Set exec to be used
         MVC   RXCALL+27(08),CAPUC          parm1 = Commarea fp
         MVC   RXCALL+37(04),=CL4' (  '     option
         MVC   RXCALL+41(04),=CL4'A E '     o1 = Action Encode
         SPACE 1
         XC    MSGAREA,MSGAREA              Trace Rexx command
         MVC   MSGAREAM,MSGEI2
         MVC   MSGAREAM+25(55),RXCALL
         SPACE 1
         STM   R0,R15,FSAVE
         L     R15,=AL4(MSGTOTD)
         LM    R0,R14,SAVE5
         BALR  R6,R15
         LM    R0,R15,FSAVE
         SPACE 1
*
* =====> Call Rexx runtime
*
         SPACE 1
EC1      DS    0H
         SPACE 1
         EXEC  CICS LINK PROGRAM(=CL8'CICREXD')                        |
                         COMMAREA(RXCALL)                              |
                         LENGTH(=AL2(L'RXCALL))                        |
                         NOHANDLE                                      |
                         RESP(RESP)                                    |
                         RESP2(RESP2)
         SPACE 1
         XC    MSGAREA,MSGAREA              Trace Exit
         MVC   MSGAREAM,MSGEI3
         STM   R0,R15,FSAVE
         LA    R14,RESP
         LA    R15,MSGAREAM+27
         L     R1,=AL4(CONV4TO8)
         LM    R2,R13,SAVE5+8
         BALR  R6,R1
         LM    R0,R15,FSAVE
         LA    R14,RESP2
         LA    R15,MSGAREAM+36
         L     R1,=AL4(CONV4TO8)
         LM    R2,R13,SAVE5+8
         BALR  R6,R1
         LM    R0,R15,FSAVE
         SPACE 1
         STM   R0,R15,FSAVE
         L     R15,=AL4(MSGTOTD)
         LM    R0,R14,SAVE5
         BALR  R6,R15
         LM    R0,R15,FSAVE
         SPACE 1
*
* =====> Returned from Rexx
*
         SPACE 1
EC2      DS    0H
         SPACE 1
         XC    MSGAREA,MSGAREA              Trace Returned area
         MVC   MSGAREAM,MSGEI4
         MVC   MSGAREAM+25(55),RXCALL
         SPACE 1
         STM   R0,R15,FSAVE
         L     R15,=AL4(MSGTOTD)
         LM    R0,R14,SAVE5
         BALR  R6,R15
         LM    R0,R15,FSAVE
         SPACE 1
         XC    MSGAREA,MSGAREA              Trace Return Code
         MVC   MSGAREAM,MSGEI5
         STM   R0,R15,FSAVE
         LA    R14,RXCALL
         LA    R15,MSGAREAM+31
         L     R1,=AL4(CONV4TO8)
         LM    R2,R13,SAVE5+8
         BALR  R6,R1
         LM    R0,R15,FSAVE
         L     R15,=AL4(MSGTOTD)
         LM    R0,R14,SAVE5
         BALR  R6,R15
         LM    R0,R15,FSAVE
         SPACE 1
*
* =====> If Rexx returned Non-zero force this into the Commarea
*
         SPACE 1
EC3      DS    0H
         SPACE 1
         L     R15,RXCALL                   Get Rexx Return Code
         LTR   R15,R15                      Zero?
         BZ    EC31                          Yes - keep priorly set
         L     R14,CAPU                      No  - address commarea
         MVC   ENCODE_RESPONSE-ENCODE_PARMS(4,R14),=F'4'  Exception
         ST    R15,ENCODE_REASON-ENCODE_PARMS(R14)        Rexx RC
         SPACE 1
EC31     DS    0H
         SPACE 1
*
* =====> Request succeeded
*
         SPACE 1
ECXY     DS    0H
         SPACE 1
         B     ECX                          Exit
         SPACE 1
*
* =====> Request failed
*
         SPACE 1
ECXN     DS    0H
         SPACE 1
         B     ECX                          Exit
         SPACE 1
*
* =====> Return to caller
*
         SPACE 1
ECX      DS    0H
         SPACE 1
         XC    MSGAREA,MSGAREA
         MVC   MSGAREAM,MSGEI6              Trace exit
         STM   R0,R15,FSAVE
         L     R15,=AL4(MSGTOTD)
         LM    R0,R14,SAVE5
         BALR  R6,R15
         LM    R0,R15,FSAVE
         SPACE 1
         LM    R0,R15,SAVE5                 Restore regs
         BR    R14                          Return
         POP   USING                        Restore Addressibility
         SPACE 2
*
* =====> Decode Info Messages
*
*                   0....+....1....+....2....+....3....+....4....+....5
*              ....+....6....+....7....+....
MSGEI1   DC    CL80'RAHRC9201I Entering Encode routine                 |
                                            '
MSGEI2   DC    CL80'RAHRC9202I Rexx calling                            |
                                            '
MSGEI3   DC    CL80'RAHRC9203I XC Link to Rexx xxxxxxxx/xxxxxxxx       |
                                            '
MSGEI4   DC    CL80'RAHRC9204I Rexx returned                           |
                                            '
MSGEI5   DC    CL80'RAHRC9205I Rexx return code is xxxxxxxx            |
                                            '
MSGEI6   DC    CL80'RAHRC9206I Leaving Encode routine                  |
                                            '
         SPACE 2
         EJECT
*
* ====================================================================
* =             Decode Literals                                      =
* ====================================================================
*
         SPACE 2
         LTORG
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =             Revert back to main CSECT                            =
* ====================================================================
*
         SPACE 2
RAHRCONV CSECT
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =                                                                  =
* =                Messages                                          =
* =                                                                  =
* =    These Messages are in their own CSECT, and are used via       =
* =                                                                  =
* =          L   Rm,dest                                             =
* =          L   Rn,=AL4(MSGnn)                                      =
* =          MVC 0(80,Rm),0(Rn)                                      =
* =                                                                  =
* ====================================================================
*
         SPACE 2
RAHRMSGS CSECT
         SPACE 2
RAHRMSGS AMODE 31
RAHRMSGS RMODE ANY
         SPACE 2
*                   0....+....1....+....2....+....3....+....4....+....5
*              ....+....6....+....7....+....
MSG01    DC    CL80'RAHRC1001S No commarea supplied for Converter      |
                                            '
MSG02    DC    CL80'RAHRC1002S Unknown Converter request of <xxxxxxxx> |
                                            '
MSG03    DC    CL80'RAHRC1003S Invalid Commarea length for Decode of xx|
               xxxxxx                       '
MSG04    DC    CL80'RAHRC1004S Invalid Commarea length for Encode of xx|
               xxxxxx                       '
         SPACE 2
*                   0....+....1....+....2....+....3....+....4....+....5
*              ....+....6....+....7....+....
         SPACE 2
MSGE01   DC    CL80'RAHRC2201W Function Request started just before end|
                of area - zeroed away       '
MSGE02   DC    CL80'RAHRC2202W Function Request not understood - zeroed|
                away                        '
MSGE03   DC    CL80'RAHRC2203W Function Password Request is invalid - z|
               eroed away                   '
MSGE04   DC    CL80'RAHRC2204E Function Password Req error RC/AC xxxxxx|
               xx/xxxxxxxx/xxxxxxxx/xxxxxxxx'
MSGE05   DC    CL80'RAHRC2205W Function UserId Request is invalid - zer|
               oed away                     '
         SPACE 2
*                   0....+....1....+....2....+....3....+....4....+....5
*              ....+....6....+....7....+....
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =             Revert back to main CSECT                            =
* ====================================================================
*
         SPACE 2
RAHRCONV CSECT
         SPACE 2
         EJECT
         SPACE 2
*
* ====================================================================
* =             End of program                                       =
* ====================================================================
*
         SPACE 2
         END   RAHRCONV
